=== debian/changelog ===
gargoyle-free (2026.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2023.1+dfsg
  * Disable useless Salsa CI jobs
  * Bump Standards-Version to 4.7.3, drop Priority: tag
  * New upstream version 2026.1.1+dfsg
  * Copyright review: there is a new FrankenDrift engine,
    but this is DotNet / Windows only
  * Refresh patches
  * Add build-dep on libturbojpeg0-dev

 -- Alexandre Detiste <tchet@debian.org>  Fri, 27 Feb 2026 12:04:03 +0100
